找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 2817|回复: 5

[研讨] 关于 OnSegmentAt 中的 value 参数

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-7-2 18:18:18 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
本帖最后由 csharp 于 2014-7-2 18:19 编辑

在Help中
[return: MarshalAs(UnmanagedType.U1)]
public virtual bool OnSegmentAt(
    int index,
    Point2d pt2d,
    double value
);
int index
Input index (0 based) of the vertex
Point2d pt2d
Input point (in polyline OCS coords) to check at vertex index
double value
Output parameter of at vertex index

这个 value 说明是 output parameter ,在 ARX Help 也是这样的,

virtual Adesk::Boolean onSegAt(
     unsigned int index,
     const AcGePoint2d& pt2d,
     double& param) const;

Parameters
Description
unsigned int index
Input index (0 based) of the vertex
const AcGePoint2d& pt2d
Input point (in polyline OCS coords) to check at vertex index
double& param
Output parameter of at vertex index

这是http://adndevblog.typepad.com/autocad/2012/06/use-getclosestpointto-and-onsegat-to-locate-a-polyline-vertex-near-a-point.html
一个例子
static void TEST_PointOnPoly(void)
{

  ads_name ename;
  ads_point pt, ptWcs;
  AcDbObjectId Id;

  if(acedEntSel(_T("Select Pline: "),
                      ename,pt)!=RTNORM)
   return;

  // Convert to WCS incase selection was made
  // while in a UCS.
  acdbUcs2Wcs(pt, ptWcs, Adesk::kFalse);
  acdbGetObjectId(Id,ename);
  AcDbEntity* pEnt;
  acdbOpenObject(pEnt,Id,AcDb::kForRead,false);

  AcDbPolyline* pLine=NULL;
  pLine=AcDbPolyline::cast(pEnt);

  if(!pLine)
  {
   acutPrintf(_T
    ("Selected Entity not a Polyline"));
   pEnt->close();
   return;
  }

  AcGePoint3d clickpt;
  // This will convert the pick point to a
  // point on the polyline
  pLine->getClosestPointTo(asPnt3d(ptWcs), clickpt);
  // Convert to 2d point, needed below...
  AcGePoint2d clickpt2d(clickpt.x, clickpt.y);

  for(unsigned int c=0; pLine->numVerts() > c ; c++)
  {
   double segParam;
   // This is the test filter here...it uses the
   // nifty API onSegAt
   if(pLine->onSegAt(c, clickpt2d, segParam))  
   {
    acutPrintf(_T("Selected Segment: %d \n"),c+1);
    break;
   }
  }
  pLine->close();
}

在 Net 中测试这个 OnSegmentAt 怎么都没有 output , 自己就写了一个, 可以用来测试自交点所在的实际参数(xdrx_polyline_onsegat)


  1.         // based on article by Wayne Brill
  2.         // http://adndevblog.typepad.com/autocad/2012/06/use-getclosestpointto-and-onsegat-to-locate-a-polyline-vertex-near-a-point.html
  3.         [CommandMethod("oseg")]
  4.         public static void TEST_PointOnPoly()
  5.         {

  6.             Database db = Application.DocumentManager.MdiActiveDocument.Database;

  7.             Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

  8.             CoordinateSystem3d cs = ed.CurrentUserCoordinateSystem.CoordinateSystem3d;

  9.             Plane plan = new Plane(Point3d.Origin, cs.Zaxis);

  10.             Application.SetSystemVariable("osmode", 512);

  11.             using (Transaction tr = db.TransactionManager.StartTransaction())
  12.             {
  13.                 try
  14.                 {
  15.                     Entity ename;

  16.                     Point3d pt;

  17.                     Point3d ptWcs;

  18.                     PromptEntityOptions peo = new PromptEntityOptions("\nSelect Pline: ");

  19.                     peo.SetRejectMessage("\nYou have to select LWPOLYLINE!");

  20.                     peo.AddAllowedClass(typeof(Polyline), false);

  21.                     PromptEntityResult res = ed.GetEntity(peo);

  22.                     if (res.Status != PromptStatus.OK) return;

  23.                     ObjectId id = res.ObjectId;

  24.                     // Convert to WCS incase selection was made

  25.                     // while in a UCS.

  26.                     pt = res.PickedPoint;

  27.                     // Transform from UCS to WCS

  28.                     Matrix3d mat =

  29.                       Matrix3d.AlignCoordinateSystem(

  30.                         Point3d.Origin,

  31.                         Vector3d.XAxis,

  32.                         Vector3d.YAxis,

  33.                         Vector3d.ZAxis,

  34.                         cs.Origin,

  35.                         cs.Xaxis,

  36.                         cs.Yaxis,

  37.                         cs.Zaxis

  38.                       );

  39.                     ptWcs = pt.TransformBy(mat);

  40.                     ename = tr.GetObject(id, OpenMode.ForRead) as Entity;

  41.                     Polyline pline = ename as Polyline;

  42.                     if (pline == null)
  43.                     {

  44.                         ed.WriteMessage("\nSelected Entity is not a Polyline");

  45.                         return;

  46.                     }

  47.                     Point3d clickpt = pline.GetClosestPointTo(ptWcs, false);

  48.                     for (int c = 0; c < pline.NumberOfVertices; c++)
  49.                     {

  50.                         //double segParam = new double();
  51.                         double segParam;

  52.                         // This is the test filter here...it uses the

  53.                         // nifty API OnSegmentAt

  54.                         if (MyOnSegmentAt((Curve)ename,c, clickpt, out segParam))
  55.                         {

  56.                             ed.WriteMessage("\nSelected Segment: {0} \n", c + 1);
  57.                             ed.WriteMessage("\nSelected Param: {0} \n", segParam.ToString());
  58.                             break;

  59.                         }

  60.                     }
  61.                 }

  62.                 catch (System.Exception ex)
  63.                 {

  64.                     ed.WriteMessage("\n" + ex.Message + "\n" + ex.StackTrace);

  65.                 }

  66.             }

  67.         }

  68.         private static  bool MyOnSegmentAt(Curve cv, int index, Point3d pt, out double pams )
  69.         {
  70.             Polyline pl = cv as Polyline;
  71.             int numVerts = pl.NumberOfVertices;
  72.             Point2d npt = new Point2d(pt.X, pt.Y);
  73.             for (int i = 0; i < numVerts -1; i++)
  74.             {
  75.                 if (pl.OnSegmentAt(i, npt, 0.0))
  76.                 {
  77.                     SegmentType pType = pl.GetSegmentType(i);
  78.                     double iDist = cv.GetDistanceAtParameter((double) i);
  79.                     if (pType == SegmentType .Line)
  80.                     {
  81.                         Point3d p1 = cv.GetPointAtParameter((double)i);
  82.                         
  83.                         double pDist = p1.DistanceTo( pt);
  84.                         pams = cv.GetParameterAtDistance(pDist + iDist);
  85.                         return true;
  86.                     }
  87.                     else if (pType == SegmentType.Arc )
  88.                     {
  89.                         Point3d sPnt = cv.GetPointAtParameter( (double )i);
  90.                         Point3d ePnt = cv.GetPointAtParameter((double) i + 1.0);
  91.                         CircularArc3d arc = new CircularArc3d( sPnt ,pt,ePnt );

  92.                         Point3d pCen = arc.Center;
  93.                         double radius = arc.Radius;

  94.                         Vector3d vStart = pCen.GetVectorTo(sPnt);
  95.                         Vector3d vPnt = pCen.GetVectorTo(pt);

  96.                         double jiajiao = vStart.GetAngleTo(vPnt, vStart);
  97.                         double dis = jiajiao * radius;

  98.                         pams = cv.GetParameterAtDistance(dis + iDist );
  99.                         return true;
  100.                     }
  101.                     else
  102.                     {
  103.                         pams = -1;
  104.                         return false;
  105.                     }
  106.                 }
  107.             }
  108.             pams = -1;
  109.             return false;
  110.         }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 859个

财富等级: 财运亨通

 楼主| 发表于 2014-7-2 21:55:39 来自手机 | 显示全部楼层
for 循环不对,这样只返回第一个
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 859个

财富等级: 财运亨通

 楼主| 发表于 2014-7-3 09:10:18 | 显示全部楼层
本帖最后由 csharp 于 2014-7-3 09:16 编辑

  1.         public static bool MyOnSegmentAt(Polyline pl, int index, Point3d pt, out double value)
  2.         {
  3.             Curve cv = pl as Curve;
  4.             Point2d npt = new Point2d(pt.X, pt.Y);
  5.             if (pl.OnSegmentAt(index, npt, 0.0))
  6.             {
  7.                 SegmentType pType = pl.GetSegmentType(index);
  8.                 double iDist = cv.GetDistanceAtParameter((double)index);
  9.                 if (pType == SegmentType.Line)
  10.                 {
  11.                     Point3d p1 = cv.GetPointAtParameter((double)index);
  12.                     double pDist = p1.DistanceTo(pt);
  13.                     value = (cv.GetParameterAtDistance(pDist + iDist));
  14.                     return true;
  15.                 }
  16.                 else if (pType == SegmentType.Arc)
  17.                 {
  18.                     Point3d sPnt = cv.GetPointAtParameter((double)index);
  19.                     Point3d ePnt = cv.GetPointAtParameter((double)index + 1.0);
  20.                     CircularArc3d arc = new CircularArc3d(sPnt, pt, ePnt);

  21.                     Point3d pCen = arc.Center;
  22.                     double radius = arc.Radius;

  23.                     Vector3d vStart = pCen.GetVectorTo(sPnt);
  24.                     Vector3d vPnt = pCen.GetVectorTo(pt);

  25.                     double jiajiao = vStart.GetAngleTo(vPnt, vStart);
  26.                     double dis = jiajiao * radius;

  27.                     value = cv.GetParameterAtDistance(dis + iDist);
  28.                     return true;
  29.                 }
  30.                 else if (pType == SegmentType.Point | pType == SegmentType.Coincident)
  31.                 {
  32.                     value = index;
  33.                     return true;
  34.                 }
  35.                 else
  36.                 {
  37.                     value = -1.0;
  38.                     return false;
  39.                 }
  40.             }
  41.             value = -1.0;
  42.             return false;
  43.         }
复制代码
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2014-7-3 10:13:43 | 显示全部楼层
尽管在楼主最新编辑后,把MyOnSegmentAt的参数名改了,但Value的值还是Parameter的值
请问,为什么不直接用
pline.GetParameterAtPoint(clickpt);
而要用
MyOnSegmentAt((Curve)ename,c, clickpt, out segParam)
这样做的好处是什么?
请指教

点评

自相交的 Pline 同一个点(自相交点)应该是有不同的 Param ,但 GetParamAtPoint 只能返回最前面段上的 Param,不能获取后面段上的参数  详情 回复 发表于 2014-7-3 11:11
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 859个

财富等级: 财运亨通

 楼主| 发表于 2014-7-3 11:11:19 | 显示全部楼层
本帖最后由 csharp 于 2014-7-3 11:23 编辑
PLgis 发表于 2014-7-3 10:13
尽管在楼主最新编辑后,把MyOnSegmentAt的参数名改了,但Value的值还是Parameter的值
请问,为什么不直接 ...

自相交的 Pline 同一个点(自相交点)应该是有不同的 Param ,但 GetParameterAtPoint 只能返回最前面段上的 Param,不能获取后面段上的参数

如图上的交点 用 GetParameterAtPoint 只能获取 小于 1 的一个参数,2 - 3 之间那个参数获取不到的

vlax-curve-getparamatpoint 也是这样的

_$ (setq pts (xdrx_entity_intersectwith (car (entsel)) (car (entsel)) 0))
((2452.25 1550.65 0.0) (2150.48 1251.6 0.0) (2354.39 1081.48 0.0))
_$ (mapcar '(lambda (x) (vlax-curve-getparamatpoint (car (entsel)) x)) pts)
(1.0 0.514371 2.0)
_$
onsegat.jpg
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2014-7-3 15:55:14 | 显示全部楼层
测试了一下,确实如此
非常感谢csharp的帮助,谢谢
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-12-19 02:01 , Processed in 0.492964 second(s), 44 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表